/*
 * Copyright 2012 Intel Corporation.
 *
 * This file is subject to the Intel Sample Source Code License. A copy
 * of the Intel Sample Source Code License is included.
 */
/**
 Description:
 hello world for MYO shared programming model
 In this example, host and card access one shared data(*buffer), which is created
 at CPU and pass its pointer to card via the parameter of myoiRemoteCall.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "myo.h"
#include "myoimpl.h"

extern MyoError myoiUserInit(void);

#define MAXWORLD 50
#define shared
//#define MINE
shared void *ptr;
int main(int argc, char * argv[]){
	
    MyoiRFuncCallHandle rpcHandle ;
    if(MYO_SUCCESS != myoiLibInit(NULL, (void*)&myoiUserInit)) {
        printf("Failed to initialize MYO runtime\n");
        return -1;
    }
    printf("====================CPU Client==================\n");
    fflush(stdout);
    shared char * buffer;
    char temp[50] = "hello world";
    if((buffer = (char *)myoSharedMalloc(sizeof(char) * MAXWORLD *2)) == NULL) {
        fprintf(stderr, "myoSharedMalloc buffer Failed\n");
        exit(1);
    }
#ifdef MINE
    myoAcquireOwnership();//acquireOwnship 
#endif
    strcpy(buffer, temp);
    printf("%s\n", buffer);
    fflush(stdout);
#ifdef MINE
    myoReleaseOwnership(); //Release before RPC
#else
    myoRelease(); //Release before RPC
#endif
    rpcHandle = myoiRemoteCall((char*)"kernel", buffer, 0);
    myoiGetResult(rpcHandle);
#ifdef MINE
    myoAcquireOwnership();//acquire after RPC return
#else
    myoAcquire();//acquire after RPC return
#endif
    printf("%s\n", buffer);
    fflush(stdout);
    printf("================================================\n");
    myoiLibFini();
    
    printf("*** Succeed\n");
    return (0);
}

//Init Function, Generated by Translator or by Hand
MyoError myoiUserInit(void){
   MyoError ret;
   ret = MYO_SUCCESS;

   return ret;
}
