/*
 * Copyright 2012 Intel Corporation.
 *
 * This file is subject to the Intel Sample Source Code License. A copy
 * of the Intel Sample Source Code License is included.
 */
/**
 Description:
 hello world for MYO shared programming model
 In this example, host and card access one shared data(*buffer), which is created
 at CPU and pass its pointer to card via the parameter of myoiRemoteCall.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "myo.h"
#include "myoimpl.h"
#define shared
//#define MINE

extern MyoError myoiUserInit(void);

//Remote function
void kernel(char * buffer)
{
#ifdef MINE
    myoAcquireOwnership(); //acquire in service
#else
    myoAcquire(); //acquire in service
#endif
    printf("%s\n", buffer);
    fflush(stdout);

    char temp[50] = "world hello";
    strcpy( buffer, temp);
#ifdef MINE
    myoReleaseOwnership(); //release before return
#else
    myoRelease(); //release before return
#endif
}

int main(int argc, char * argv[]){
    printf("====================CARD Service==================\n");
    myoiLibInit(NULL, (void*)&myoiUserInit);
    myoiLibFini();
    printf("=================================================\n");
    return (0);
}

//Init Function, Generated by Translator or by Hand
MyoError myoiUserInit(void){
    MyoError ret;
    ret = MYO_SUCCESS;

    ret = myoiRemoteFuncRegister((MyoiRemoteFuncType) kernel, "kernel");

    return ret;
}
