/*
 * Copyright 2012 Intel Corporation.
 *
 * This file is subject to the Intel Sample Source Code License. A copy
 * of the Intel Sample Source Code License is included.
 */
/**
 Description:
 linkedlist for MYO shared programming model
 In this example, one pointer-contained structure store in MYO shared space. 
 Host and card can walk through the linkedlist w/o the need of marshalling.
*/

#include "linkedlist.h"

extern MyoError myoiUserInit(void);
//Remote function
/** @FUNC calculateKernel                                                                                                                                    
 ** Add 1000 for the whole linkedlist
 ** @RETURN:  
 */
void calculateInMIC(LinkedList *head)
{
    LinkedListNode *temp;

    /*Check whether linked list is empty*/
    assert(head);

    /*add 1000 for each nodes in linkedlist*/
    printf("CARD: add 1000 for each nodes in linkedlist\n");
    myoAcquire(); //acquire in service
    temp = head->next;
    while(temp!=NULL){
        temp->data += 1000;
        temp=temp->next;
    }
    myoRelease(); //release before return

    return;
}

int main(int argc, char * argv[]){
    printf("====================CARD Service==================\n");
    myoiLibInit(NULL, (void*)&myoiUserInit);
    myoiLibFini();
    printf("=================================================\n");
    return (0);
}

//Init Function, Generated by Translator or by Hand
MyoError myoiUserInit(void){
    MyoError ret;
    ret = MYO_SUCCESS;

    ret = myoiRemoteFuncRegister( (MyoiRemoteFuncType) calculateInMIC, "calculateInMIC");

    return ret;
}
