/*
 * Copyright 2012 Intel Corporation.
 *
 * This file is subject to the Intel Sample Source Code License. A copy
 * of the Intel Sample Source Code License is included.
 */
/**
 Description:
 Reverse/Forward Acceleration for MYO shared programming model
 In this example, host and card access one shared data(*hostbuffer), which is 
 created at host and pass its pointer to card via the parameter of 
 myoiRemoteCall(Forward Acceleration). The card calls the function on the 
 host using myoiRemotecall(Reverse Acceleration)
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "myo.h"
#include "myoimpl.h"
#define shared

extern MyoError myoiUserInit(void);

//Remote function
void kernel(int* hostbuffer)
{
    int temp;
    printf("Inside card Kernel \n");
    MyoiRFuncCallHandle rpcHandle ;
    myoAcquire(); //acquire in service
    printf("Received from host %d\n", *hostbuffer);
    temp = *hostbuffer;
    *hostbuffer =  temp * temp;
    myoRelease();     
    rpcHandle = myoiRemoteCall((char*)"hostkernel", hostbuffer, -1);
    myoiGetResult(rpcHandle);
    myoAcquire();
    printf("Received from host %d\n", *hostbuffer);
    fflush(stdout);


    myoRelease(); //release before return
}

int main(int argc, char * argv[]){ 
    MyoiRFuncCallHandle rpcHandle ;
    printf("====================MIC Service==================\n");
    myoiLibInit(NULL, (void*)&myoiUserInit);
    myoiLibFini();
    printf("=================================================\n");
    return (0);
}

//Init Function, Generated by Translator or by Hand
MyoError myoiUserInit(void){
    MyoError ret;
    ret = MYO_SUCCESS;

    ret = myoiRemoteFuncRegister((MyoiRemoteFuncType) kernel, "kernel");

    return ret;
}
